<template>
  <div>
    <CoscineHeadline :headline="$t('page.project.member', 2)" />
    <!-- Members -->
    <b-row v-if="!projectRoles" align-h="center" class="my-4">
      <b-spinner variant="primary" />
    </b-row>
    <div class="list">
      <div class="user-complete-name-list container-fluid">
        <span v-for="(projectRole, index) in projectRoles" :key="index">
          <b-row align-v="center" class="mb-1">
            <!-- Icon -->
            <i-bi-person variant="primary" class="user-image" />

            <!-- Member Details -->
            <b-col class="user-details">
              <!-- Member Display Name -->
              {{ projectRole.user ? projectRole.user.displayName : "" }}
              <!-- Member Role Badge-->
              <span
                v-if="
                  projectRole.user &&
                  currentUser &&
                  projectRole.user.id === currentUser.id
                "
                class="badge rounded-pill text-bg-primary ms-2"
              >
                {{ projectRole.role?.displayName }}
              </span>
              <span v-else class="badge rounded-pill text-bg-secondary ms-2">
                {{ projectRole.role?.displayName }}
              </span>
              <br />
              <!-- Member Email -->
              <a
                v-b-tooltip.hover.bottom="{
                  title: projectRole.user ? projectRole.user.email : '',
                  boundary: 'viewport',
                }"
                class="text-primary"
                :href="
                  projectRole.user
                    ? `mailto:${projectRole.user.email}`
                    : undefined
                "
              >
                {{ projectRole.user ? projectRole.user.email : "" }}
              </a>
            </b-col>

            <!-- Leave Button -->
            <span class="col-sm-1">
              <b-button
                v-if="
                  projectRole.user &&
                  currentUser &&
                  projectRole.user.id === currentUser.id
                "
                v-b-tooltip.hover.left="{
                  title:
                    ownerCount && ownerCount < 2 && isOwner
                      ? $t('page.project.members.tooltipDisabled')
                      : $t('page.project.members.tooltip'),
                }"
                class="float-end"
                variant="primary"
                name="leave"
                size="sm"
                :disabled="
                  ownerCount !== undefined && ownerCount < 2 && isOwner
                "
                tabindex="0"
                @click="leaveModal = true"
              >
                {{ $t("buttons.leave") }}
              </b-button>
            </span>
          </b-row>
        </span>
      </div>

      <!-- Manage Members Link -->
      <div v-if="isOwner" class="mt-2 text-primary">
        <router-link :to="{ name: 'project-members' }">
          {{ $t("page.project.members.toProjectMembers") }}
        </router-link>
      </div>

      <!-- Leave Modal -->
      <b-modal
        id="leaveModal"
        v-model="leaveModal"
        hide-footer
        :title="
          $t('page.project.members.modal.title', {
            name: project ? project.displayName : '',
          })
        "
      >
        <!-- Leave Modal Body -->
        <div class="mb-3">
          {{
            $t("page.project.members.modal.body", {
              name: project ? project.displayName : "",
            })
          }}
        </div>

        <!-- Leave Modal Buttons -->
        <b-button
          ref="modalLeaveProjectCancel"
          class="float-end"
          variant="primary"
          autofocus
          @click="leaveModal = false"
        >
          {{ $t("buttons.cancel") }}
        </b-button>
        <b-button class="float-start" variant="danger" @click="leaveProject">
          {{ $t("buttons.leave") }}
        </b-button>
      </b-modal>
    </div>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useProjectStore from "../../store";
import useUserStore from "@/modules/user/store";
import type {
  ProjectDto,
  ProjectRoleDto,
  UserDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  setup() {
    const projectStore = useProjectStore();
    const userStore = useUserStore();

    return { projectStore, userStore };
  },

  data() {
    return {
      leaveModal: false,
      ownerString: "Owner",
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    projectRoles(): ProjectRoleDto[] | null {
      return this.projectStore.currentProjectRolesSorted;
    },
    currentUser(): UserDto | null | undefined {
      return this.userStore.user;
    },
    currentUserProjectRole(): ProjectRoleDto | undefined {
      return this.projectRoles?.find(
        (r) =>
          r.user?.id === this.currentUser?.id &&
          r.project?.id === this.project?.id,
      );
    },
    isOwner(): boolean | undefined {
      return this.projectStore.currentUserRoleIsOwner;
    },
    ownerCount(): number | undefined {
      const currentRoles = this.projectStore.currentProjectRoles;
      if (currentRoles) {
        return currentRoles.filter(
          (projectRole) =>
            projectRole.role &&
            projectRole.role.displayName === this.ownerString,
        ).length;
      }
      return undefined;
    },
  },

  methods: {
    leaveProject() {
      if (this.project) {
        this.projectStore.deleteProjectAssociation(
          this.project,
          this.currentUserProjectRole,
        );
      }
    },
  },
});
</script>

<style scoped>
.user-image {
  width: 3.5rem;
  height: 3.5rem;
  color: var(--bs-primary);
}

.user-details {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.user-complete-name-list {
  max-height: 25rem;
  overflow-x: hidden;
  overflow-y: auto;
}
</style>
